create or replace
PROCEDURE ETL_RESUSAPORE
                     (P_DTINI      IN DATE,
                      P_DTFINA     IN DATE,
                      P_GRUPO    IN VARCHAR2)
IS
   V_DATA            DATE;
   V_DTFIM           DATE;
   V_DTINI           DATE;

   V_FATLIQ          FLOAT NOT NULL  := 0;
   V_FATBRUT         FLOAT NOT NULL  := 0;
   V_IMPOSTO         FLOAT NOT NULL  := 0;
   V_TEMP_FATBRUT    FLOAT NOT NULL  := 0;
   V_TEMP_IMPOSTO    FLOAT NOT NULL  := 0;

   V_DESPESA         FLOAT NOT NULL  := 0;
   V_MOBRA           FLOAT NOT NULL  := 0;

   V_ESTOQUE_INICIAL FLOAT NOT NULL  := 0;
   V_ESTOQUE_FINAL   FLOAT NOT NULL  := 0;
   V_CUSTORETIRADA   FLOAT NOT NULL  := 0;
   V_VRAJUSNEGATIVO  FLOAT NOT NULL  := 0;
   V_VRAJUSPOSITIVO  FLOAT NOT NULL  := 0;

   V_TXTAR           FLOAT NOT NULL  := 0;
   V_TXADM           FLOAT NOT NULL  := 0;
   V_CUSTOCMP        FLOAT NOT NULL  := 0;
  
   V_ORCAFATBRUT     FLOAT NOT NULL  := 0;
   V_ORCAIMPOSTO     FLOAT NOT NULL  := 0;
   V_ORCAFATLIQ      FLOAT NOT NULL  := 0; 
   V_ORCARETIGER     FLOAT NOT NULL  := 0;
   V_ORCACUSTOCMP    FLOAT NOT NULL  := 0;
   V_ORCAMDOENGER    FLOAT NOT NULL  := 0;
   V_ORCADESPEGER    FLOAT NOT NULL  := 0;
   V_ORCATXADMGER    FLOAT NOT NULL  := 0;  
   V_VRPERCTXTAR     FLOAT NOT NULL  := 0;    
     
   V_CDFILISUBGR     FILIAL.CDFILIAL%TYPE;
   V_CDSEQUENCIAL    VARCHAR2(20);
   V_NIVEL           VARCHAR2(20);
   V_DIAUTIL1        VARCHAR2(05);
   V_DIAUTIL2        VARCHAR2(05);
   V_TIPOFATU        VARCHAR2(30);

   V_VRORCAFINA1     FLOAT NOT NULL  := 0;
   V_VRORCAFINA2     FLOAT NOT NULL  := 0;

   V_DTMES           VARCHAR2(07);
   V_DTANO           VARCHAR2(04);

   V_BIM             VARCHAR2(6);
   V_TRI             VARCHAR2(6);
   V_SEM             VARCHAR2(6);
   V_VRREALDESP      FLOAT  NOT NULL := 0;

   V_COUNTER         NUMBER := 0;
   V_ZERO            NUMBER := 0;
   
   V_CDSUPERVISOR    VARCHAR2(12);
   V_CDGOPERAC       VARCHAR2(12);
   V_QTFUNCFILI      NUMBER;   
BEGIN
   BEGIN
      EXECUTE IMMEDIATE('ALTER SESSION SET NLS_SORT = ''BINARY'' ');
   EXCEPTION
   WHEN OTHERS THEN
      NULL;
      /* SILENCIO A EXCEPTION DE PROPOSITO PARA NO CAUSAR ERROS DE PERMISSO  */
   END;
   V_DATA   :=  TRUNC(SYSDATE);
   V_DTINI  :=  P_DTINI;
   V_DTMES  :=  TO_CHAR(V_DTINI,'MM');
   V_DTANO  :=  TO_CHAR(V_DTINI,'YYYY');
   

   DELETE FROM ETL_RESUGER
   WHERE (ANRESUGER > V_DTANO) OR
         (ANRESUGER = V_DTANO
         AND  MERESUGER >= V_DTMES); 
   COMMIT;

   V_DTFIM  := LAST_DAY(V_DTINI);
   
   
   
   WHILE (V_DTINI  <=  P_DTFINA) LOOP /*Inicio do Loop por Data*/
       V_DTINI := TO_DATE('01'||TO_CHAR(V_DTINI,'MMYYYY'),'DDMMYYYY');
       V_DTFIM := LAST_DAY( V_DTINI);
       
       IF V_DTFIM > TRUNC(SYSDATE) THEN
          V_DTFIM := TRUNC(SYSDATE);   
       END IF;
       
       V_DTMES  :=  TO_CHAR(V_DTFIM,'MM');
       V_DTANO  :=  TO_CHAR(V_DTFIM,'YYYY');
       V_BIM := TRUNC ((V_DTMES - 1) / 2) + 1;
       V_TRI := TRUNC ((V_DTMES - 1) / 3) + 1;
       V_SEM := TRUNC ((V_DTMES - 1) / 6) + 1;
       
       FOR C_ETL IN
          (SELECT F.CDFILIAL, CDEMPRESA,
                  F.CDAREAGERE    AS CDAREAGERE,                                    
                  F.CDSEGMER      AS CDSEGMER,
                  F.DTINICIALBI   AS DTINICIALBI,
                  P.CDTIPOFATUR   AS CDTIPOFATUR                  
           FROM   FILIAL F,  PARAMFILIAL P
           WHERE  (F.CDFILIAL = P.CDFILIAL)
             AND  F.IDFUNCAOFILI IS NULL /*Desconsidera Regionais e Operadores Logsticos*/
             AND  F.DTINICIALBI IS NOT NULL
           )
       LOOP /*Inicio do Loop por Filial*/
       
/* VALORES DE ORAMENTO*/
          IF TO_DATE('01'||TO_CHAR(C_ETL.DTINICIALBI,'MMYYYY'),'DDMMYYYY') <= V_DTINI THEN
             FOR C_ORCAMENTO IN
                (SELECT
                     C.CDCLASSFINA, NVL(O.VRORCAFINA,0) AS VRORCAFINA
                 FROM
                     CLASSFINANC C,
                     (SELECT CDCLASSFINA, VRORCAFINA
                      FROM ORCAFINA
                      WHERE CDFILIAL   = C_ETL.CDFILIAL 
                        AND DTORCAFINA BETWEEN V_DTINI AND V_DTFIM) O
                 WHERE
                     C.CDCLASSFINA LIKE 'ROP%' AND
                     C.CDCLASSFINA = O.CDCLASSFINA(+)
                  
                 UNION ALL
                  
                 SELECT
                     C.CDCLASSFINA, NVL(C.VRORCAFINA,0) AS VRORCAFINA
                 FROM
                     (SELECT 'ROP0071' AS CDCLASSFINA, NVL(VRTXADMREGI,0) AS VRORCAFINA
                      FROM HISTFILIAL
                      WHERE CDFILIAL   = C_ETL.CDFILIAL 
                        AND DTREFEHIST BETWEEN V_DTINI AND V_DTFIM) C 
                 )
             LOOP
                IF     C_ORCAMENTO.CDCLASSFINA = 'ROP001'  THEN   V_ORCAFATBRUT  := C_ORCAMENTO.VRORCAFINA;
                ELSIF  C_ORCAMENTO.CDCLASSFINA = 'ROP002'  THEN   V_ORCAIMPOSTO  := C_ORCAMENTO.VRORCAFINA;
                ELSIF  C_ORCAMENTO.CDCLASSFINA = 'ROP003'  THEN   V_ORCAFATLIQ   := C_ORCAMENTO.VRORCAFINA;
                ELSIF  C_ORCAMENTO.CDCLASSFINA = 'ROP004'  THEN   V_ORCARETIGER  := C_ORCAMENTO.VRORCAFINA;
                ELSIF  C_ORCAMENTO.CDCLASSFINA = 'ROP005'  THEN   V_ORCACUSTOCMP := C_ORCAMENTO.VRORCAFINA;
                ELSIF  C_ORCAMENTO.CDCLASSFINA = 'ROP006'  THEN   V_ORCAMDOENGER := C_ORCAMENTO.VRORCAFINA;
                ELSIF  C_ORCAMENTO.CDCLASSFINA = 'ROP007'  THEN   V_ORCADESPEGER := C_ORCAMENTO.VRORCAFINA;
                ELSIF  C_ORCAMENTO.CDCLASSFINA = 'ROP0071' THEN   V_VRPERCTXTAR  := C_ORCAMENTO.VRORCAFINA;  -- Taxa Administrativa Regional    (TAR)
                ELSIF  C_ORCAMENTO.CDCLASSFINA = 'ROP008'  THEN   V_ORCATXADMGER := C_ORCAMENTO.VRORCAFINA;  -- Taxa Administrativa Corporativa (TAC)
                END IF;
             END LOOP;
        
/* FATURAMENTO BRUTO, FATURAMENTEO LIQUIDO E IMPOSTO */
             V_FATBRUT := V_ZERO;
             V_FATLIQ  := V_ZERO;
             V_IMPOSTO := V_ZERO;
             V_TXADM   := V_ZERO;
/*PREENCHER AGORA O NUMERO DE APURAO*/
             NOVO_CODIGO('RELAPURFAT'||C_ETL.CDFILIAL, V_CDSEQUENCIAL,1);
             V_CDSEQUENCIAL := SUBSTR(V_CDSEQUENCIAL,11,10);
                  /*CALCULAR IMPOSTO E FATURAMENTO*/
             Apurac_RelGesDireta(C_ETL.CDFILIAL,V_DTINI,V_DTFIM,V_CDSEQUENCIAL,'');
             IMPOSTO_RELGESDIRETA(C_ETL.CDFILIAL,V_DTINI,V_DTFIM,V_CDSEQUENCIAL);
             
             
             BEGIN
                SELECT SUM(FAT.VRFATUSERV),SUM(FAT.VRIMPOSTO)
                INTO  V_FATBRUT, V_IMPOSTO
                FROM
                   (SELECT '0' AS CDTURNOTU, SUM(TRAB.NREFETIVOSAPGD) QTDEREFE,
                           SUM(TRAB.VRPRECUNITAPGD * TRAB.NREFETIVOSAPGD) VRFATUSERV, NVL(SUM(VRIMPOSPRODGD),0) AS VRIMPOSTO
                    FROM TRAB_APURAC_GD TRAB
                    WHERE TRAB.CDFILIALAPGD   = C_ETL.CDFILIAL                      
                      AND TRAB.DTAPURACFATGD BETWEEN V_DTINI AND V_DTFIM  
                      AND TRAB.NRAPURACGD     = V_CDSEQUENCIAL  
                    UNION ALL
                    SELECT '0' AS CDTURNOTU, SUM(TU.NREFETIVOSAPTU) QTDEREFE,
                           SUM(TU.VRPRECUNITAPTU * TU.NREFETIVOSAPTU) VRFATUSERV, NVL(SUM(VRIMPOSPRODTU),0) AS VRIMPOSTO
                    FROM TRAB_APURAC_TU TU, SERVICO S
                    WHERE TU.CDFILIALAPTU     = C_ETL.CDFILIAL                   
                      AND TU.DTAPURACFATTU BETWEEN V_DTINI AND V_DTFIM  
                      AND TU.NRAPURACTU       = V_CDSEQUENCIAL                 
                      AND TU.CDFILIALAPTU     = S.CDFILIAL                    
                      AND TU.CDSERVFILIAPTU   = S.CDSERVFILI
                    UNION ALL
                    SELECT TU.CDTURNOTU, SUM(TU.NREFETIVOSAPTU) QTDEREFE,
                           SUM(TU.VRPRECUNITAPTU * TU.NREFETIVOSAPTU) VRFATUSERV, NVL(SUM(VRIMPOSPRODTU),0) AS VRIMPOSTO
                    FROM TRAB_APURAC_TU TU
                    WHERE TU.CDFILIALAPTU     = C_ETL.CDFILIAL                   
                      AND TU.DTAPURACFATTU BETWEEN V_DTINI AND V_DTFIM  
                      AND TU.NRAPURACTU       = V_CDSEQUENCIAL
                    GROUP BY TU.CDTURNOTU
                    ) FAT
                WHERE FAT.CDTURNOTU = '0';
             EXCEPTION 
                WHEN OTHERS THEN
                   V_FATBRUT := V_ZERO;
                   V_IMPOSTO := V_ZERO;
            END;

             BEGIN
                SELECT SUM(A.VRFATUSERV), SUM(A.VRIMPOSTO)
                INTO V_TEMP_FATBRUT , V_TEMP_IMPOSTO
                FROM
                      (SELECT TE.CDSERVFILIAPEQ,
                              NVL(TE.VRPRECREALAPEQ * TE.NREFETIVOSAPEQ, 0) AS VRFATUSERV, NVL(TE.VRIMPOSPRODEQ,0) AS VRIMPOSTO
                       FROM   TRAB_APURAC_EQ TE
                       WHERE  CDFILIALAPEQ   = C_ETL.CDFILIAL     
                         AND  DTAPURACFATEQ BETWEEN V_DTINI AND V_DTFIM  
                         AND  NRAPURACEQ     = V_CDSEQUENCIAL   
                         AND  TE.IDAJUSEFETAPEQ = 'S'          
                         AND  TE.IDPRODPRINAPEQ = 'S'
                        
                       UNION ALL
                        
                       SELECT TE.CDSERVFILIAPEQ, 
                              SUM(TE.VRPRECUNITAPEQ * TRUNC(TE.NREFETIVOSAPEQ)) VRFATUSERV, NVL(SUM(VRIMPOSPRODEQ),0) AS VRIMPOSTO
                       FROM   TRAB_APURAC_EQ TE
                       WHERE  CDFILIALAPEQ   = C_ETL.CDFILIAL     
                         AND  DTAPURACFATEQ BETWEEN V_DTINI AND V_DTFIM  
                         AND  NRAPURACEQ     = V_CDSEQUENCIAL   
                         AND  TE.IDAJUSEFETAPEQ = 'N'          
                         AND  TE.IDPRODPRINAPEQ = 'N'
                       GROUP BY TE.CDSERVFILIAPEQ
                       ) A
                WHERE A.CDSERVFILIAPEQ = '00000';
             EXCEPTION
                WHEN OTHERS THEN
                   V_TEMP_FATBRUT := V_ZERO;
                   V_TEMP_IMPOSTO := V_ZERO;
             END;


            /*Apaga os dados inseridos nas tabelas temporarias*/
            DELETE FROM TRAB_APURAC_GD
            WHERE
               (CDFILIALAPGD = C_ETL.CDFILIAL) AND
               (NRAPURACGD   = V_CDSEQUENCIAL);
               
            DELETE FROM TRAB_APURAC_TU
            WHERE
               (CDFILIALAPTU = C_ETL.CDFILIAL) AND
               (NRAPURACTU   = V_CDSEQUENCIAL);
               
            DELETE FROM TRAB_APURAC_EQ
            WHERE
               (CDFILIALAPEQ = C_ETL.CDFILIAL) AND
               (NRAPURACEQ   = V_CDSEQUENCIAL);





             V_FATBRUT := V_FATBRUT + V_TEMP_FATBRUT;
             V_IMPOSTO := V_IMPOSTO + V_TEMP_IMPOSTO;

             V_FATLIQ := V_FATBRUT - V_IMPOSTO;
        /* Retirada  */ 
             BEGIN
                SELECT SUM(C.VRCUSTO) 
                INTO   V_CUSTORETIRADA
                FROM
                       (SELECT (I.QTRETIRADA * NVL(CUSTO_PRODUTO(IT.CDFILIMOVI, IT.CDPRODMOVI, NVL(P.CDTIPCUSTEST, 3), IT.DTLANCMOVI, TRUNC(SYSDATE)),0)) AS VRCUSTO
                         FROM   RETIRADA R, CARDADIA C, ITEMRETI I, TIPOPRAT T,  ITLANCTOEST IT, PARAMFILIAL P
                        WHERE  C.CDFILIAL     = C_ETL.CDFILIAL     
                          AND  C.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM 
                          AND  C.CDFILIAL     = P.CDFILIAL      
                          AND  R.CDFILIAL     = C.CDFILIAL      
                          AND  R.NRCARDAPIO   = C.NRCARDAPIO    
                          AND  R.CDFILIAL     = I.CDFILIAL      
                          AND  R.NRCARDAPIO   = I.NRCARDAPIO    
                          AND  R.NRRETIRADA   = I.NRRETIRADA    
                          AND  I.CDTIPOPRAT   = T.CDTIPOPRAT    
                          AND  I.CDFIITLANEST = IT.CDFILIAL     
                          AND  I.NRLANCESTQ   = IT.NRLANCESTQ   
                          AND  I.NRSEQUITEM   = IT.NRSEQUITEM      
                          AND  IT.IDTIPOMOVI  = '3'             
                          AND  IT.IDEVOLESTOQ = 'S') C ;
             EXCEPTION
             WHEN OTHERS THEN
                V_CUSTORETIRADA := V_ZERO;
             END;
               
         /* Ajuste positivo e negativo */

             NOVO_CODIGO('MOVIESTOQUE', V_CDSEQUENCIAL,1);
             V_CDSEQUENCIAL := SUBSTR(V_CDSEQUENCIAL,11,10);
             MOVIMENTACAO_ESTOQUE (C_ETL.CDFILIAL,' ',' ',' ',1, V_DTINI, V_DTFIM,'1','Zzzzz','3','1',V_CDSEQUENCIAL, 'N');
             BEGIN
                SELECT 
                       SUM((DECODE((I.QTLANCTOEST - R.QTTOTALANT)* -1, ABS(I.QTLANCTOEST - R.QTTOTALANT),(I.QTLANCTOEST - R.QTTOTALANT),0) *(R.VRCUSTMEDI))) AS VRNEGATIVO,
                       SUM((DECODE((I.QTLANCTOEST - R.QTTOTALANT)* -1, ABS(I.QTLANCTOEST - R.QTTOTALANT), 0, (I.QTLANCTOEST - R.QTTOTALANT)) *(R.VRCUSTMEDI))) AS VRPOSITIVO
                INTO   V_VRAJUSNEGATIVO, V_VRAJUSPOSITIVO
                FROM   LANCTOESTOQ L, ITLANCTOEST I, RELAT_MOVIEST R
                WHERE  (L.CDFILIMOVI = C_ETL.CDFILIAL) 
                  AND  (TRUNC(L.DTLANCESTQ) BETWEEN V_DTINI AND V_DTFIM) 
                  AND  (L.CDFILIAL = I.CDFILIAL) 
                  AND  (L.NRLANCESTQ = I.NRLANCESTQ) 
                  AND  (L.IDTPLANCTO = '1') 
                  AND  (R.CDFILIMOVIEST = C_ETL.CDFILIAL)      
                  AND  (R.NRRELATMOVI   = V_CDSEQUENCIAL) 
                  AND  (TRUNC(R.DTLANCMOVIEST) BETWEEN V_DTINI AND V_DTFIM) 
                  AND  (R.NRLANCMOVIEST = I.NRLANCESTQ)   
                  AND  (R.NRSEQUMOVIEST = I.NRSEQUITEM)   
                  AND  (R.IDTIPOMOVIEST = '1');
             EXCEPTION
             WHEN OTHERS THEN
                V_VRAJUSNEGATIVO := V_ZERO;
                V_VRAJUSPOSITIVO := V_ZERO;
             END;
     
             DELETE FROM RELAT_MOVIEST
             WHERE (NRRELATMOVI = V_CDSEQUENCIAL);
             
             
             
             
             
     /* Custo campras - entrada de NF */
             V_CUSTOCMP       := V_ZERO;
             V_DESPESA        := V_ZERO;
             BEGIN
                SELECT CDFILISUBGR 
                INTO   V_CDFILISUBGR
                FROM   PRSUBGRPROD
                WHERE  CDGRUPPROD = P_GRUPO 
                  AND  CDFILISUBGR = C_ETL.CDFILIAL;
             EXCEPTION
             WHEN OTHERS THEN
                V_CDFILISUBGR := '';
             END;
             BEGIN 
                SELECT SUM(VRREDESPFILI)
                INTO   V_VRREALDESP
                FROM   DESPPREVFILI
                WHERE  (CDFILIAL = C_ETL.CDFILIAL) 
                  AND  (DTPRDESPFILI BETWEEN  V_DTINI AND V_DTFIM);
             EXCEPTION
             WHEN OTHERS THEN
                V_VRREALDESP := 0;
             END;
             IF V_CDFILISUBGR IS NULL THEN
                V_CDFILISUBGR :='P';
             ELSE
                V_CDFILISUBGR := C_ETL.CDFILIAL;
             END IF;
             BEGIN
                FOR C_CUSTO IN
                   (
                   
                   SELECT
                       NT.VLRTOTAL,
                       NT.IDENTRSAIDOP, NT.IDCOMPRESROP, G.IDTPGRPRALIM,
                       VRIMPICMS, VRIMPIPI, VRIMPPIS,
                       ROUND(NVL(CUSTO_LOGISTICA_MDR(NT.CDFILIAL, NT.NRLANCTONF),0),2) AS VRCUSTOLOG,
                       VRNOTAFISC,
                       NVL(FR.VRFRETE,0) AS VRFRETE, NVL(OU.VROUTROS,0) AS VROUTROS
                    FROM
                       FORNECEDOR F, SUBGRUPPROD G, CLIENTE C, LICENCAUSO LC,
                       (SELECT
                           AN.CDSUBGRPROD, N.CDFILIAL, N.NRLANCTONF, N.DTENTRSAID, N.DTEMISSAO, N.CDFISOPENTF,
                           N.CDFORNECED, N.CDCLIENTE, N.NRLICENCAUSO, N.IDORIGDESTNF, N.CDFILIEMIT, FI.NMFILIAL, N.NRNOTAFISC, N.IDENTRSAIDOP, N.CDTIPOOPER, T.IDCOMPRESROP,
                           ROUND(N.VRNOTAFISC,2) AS VRNOTAFISC,
                           ROUND(SUM(NVL(DECODE(AN.CDSUBGRPROD, '0000000003', I.VRTOTAITEM, DECODE(PF.IDCNTRESTOQ, 'S', I.VRTOTAITEM,0)),0)),2) AS VLRTOTAL,
                           ROUND(SUM(VALOR_IMPOSTO_ITEM(I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, '00', 'I', '1')),2) AS VRIMPICMS,
                           ROUND(SUM(VALOR_IMPOSTO_ITEM(I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, '10', 'I', '1')),2) AS VRIMPIPI,
                           ROUND(SUM((VALOR_IMPOSTO_ITEM(I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, '50', 'I', '1') + VALOR_IMPOSTO_ITEM(I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, '60', 'I', '1'))),2) AS VRIMPPIS
                        FROM PRSUBGRPROD AN, NOTAFISCAL N, ITEMPRODUTO I, PRODUTO P, TIPOOPERAC T, PRODFILI PF, FILIAL FI
                        WHERE
                           (N.CDFILIRECE   = C_ETL.CDFILIAL)                AND
                           (N.DTENTRSAID BETWEEN V_DTINI AND V_DTFIM)       AND
                           (N.IDENTRSAIDOP = 'E')                           AND
                           (N.IDENTRSAIDOP = T.IDENTRSAIDOP)                AND
                           (N.CDTIPOOPER   = T.CDTIPOOPER)                  AND
                           (T.IDCOMPDOCROP = 'S')                           AND
                           (I.CDFILIAL     = N.CDFILIAL)                    AND
                           (I.NRLANCTONF   = N.NRLANCTONF)                  AND
                           (AN.CDPRODUTO   = I.CDPRODUTO)                   AND
                           (AN.CDGRUPPROD  = P_GRUPO)                       AND
                           (AN.CDFILISUBGR = V_CDFILISUBGR)                 AND
                           (I.CDPRODUTO    = P.CDPRODUTO)                   AND
                           (PF.CDFILIAL    = N.CDFILIRECE)                  AND
                           (PF.CDPRODUTO   = P.CDPRODUTO)                   AND
                           (N.CDFILIEMIT   = FI.CDFILIAL (+))
                    
                        GROUP BY
                           AN.CDSUBGRPROD, N.CDFILIAL, N.NRLANCTONF, N.DTENTRSAID, N.DTEMISSAO, N.CDFISOPENTF,
                           N.CDFORNECED, N.CDCLIENTE, N.NRLICENCAUSO, N.IDORIGDESTNF, N.CDFILIEMIT, FI.NMFILIAL, N.NRNOTAFISC, N.IDENTRSAIDOP, N.CDTIPOOPER, T.IDCOMPRESROP,
                           ROUND(N.VRNOTAFISC,2)
                        UNION
                    
                        SELECT
                           AN.CDSUBGRPROD, N.CDFILIAL, N.NRLANCTONF, N.DTENTRSAID, N.DTEMISSAO, N.CDFISOPENTF,
                           N.CDFORNECED, N.CDCLIENTE, N.NRLICENCAUSO, N.IDORIGDESTNF, N.CDFILIEMIT, FI.NMFILIAL, N.NRNOTAFISC, N.IDENTRSAIDOP, N.CDTIPOOPER, T.IDCOMPRESROP,
                           ROUND(N.VRNOTAFISC,2) AS VRNOTAFISC,
                           ROUND(SUM(NVL(DECODE(AN.CDSUBGRPROD, '0000000003', I.VRTOTAITEM, DECODE(PF.IDCNTRESTOQ, 'S', I.VRTOTAITEM,0)),0)),2) AS VLRTOTAL,
                           ROUND(SUM(VALOR_IMPOSTO_ITEM(I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, '00', 'I', '1')),2) AS VRIMPICMS,
                           ROUND(SUM(VALOR_IMPOSTO_ITEM(I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, '10', 'I', '1')),2) AS VRIMPIPI,
                           ROUND(SUM((VALOR_IMPOSTO_ITEM(I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, '50', 'I', '1') + VALOR_IMPOSTO_ITEM(I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, '60', 'I', '1'))),2) AS VRIMPPIS
                        FROM PRSUBGRPROD AN, NOTAFISCAL N, ITEMPRODUTO I, PRODUTO P, TIPOOPERAC T, PRODFILI PF, FILIAL FI
                        WHERE
                           (N.CDFILIEMIT   = C_ETL.CDFILIAL)                AND
                           (N.DTENTRSAID BETWEEN V_DTINI AND V_DTFIM)       AND
                           (N.IDENTRSAIDOP = 'S')                           AND
                           (N.IDENTRSAIDOP = T.IDENTRSAIDOP)                AND
                           (N.CDTIPOOPER   = T.CDTIPOOPER)                  AND
                           (T.IDCOMPDOCROP = 'S')                           AND
                           (I.CDFILIAL     = N.CDFILIAL)                    AND
                           (I.NRLANCTONF   = N.NRLANCTONF)                  AND
                           (AN.CDPRODUTO   = I.CDPRODUTO)                   AND
                           (AN.CDGRUPPROD  = P_GRUPO)                       AND
                           (AN.CDFILISUBGR = V_CDFILISUBGR)                 AND
                           (I.CDPRODUTO    = P.CDPRODUTO)                   AND
                           (PF.CDFILIAL    = N.CDFILIEMIT)                  AND
                           (PF.CDPRODUTO   = P.CDPRODUTO)                   AND
                           (N.CDFILIRECE   = FI.CDFILIAL (+))
                        GROUP BY
                           AN.CDSUBGRPROD, N.CDFILIAL, N.NRLANCTONF, N.DTENTRSAID, N.DTEMISSAO, N.CDFISOPENTF,
                           N.CDFORNECED, N.CDCLIENTE, N.NRLICENCAUSO, N.IDORIGDESTNF, N.CDFILIEMIT, FI.NMFILIAL, N.NRNOTAFISC, N.IDENTRSAIDOP, N.CDTIPOOPER, T.IDCOMPRESROP,
                           ROUND(N.VRNOTAFISC,2)
                       ) NT,
                       (SELECT
                           N.CDFILIAL,
                           N.NRLANCTONF,
                           ROUND(SUM(DECODE(E.IDENCARGO, 'A',I.VRITEMENCA, I.VRITEMENCA * -1)),2) AS VRFRETE
                        FROM
                           NOTAFISCAL N, TIPOOPERAC T, ENCARGO E, ITEMENCARGO I
                        WHERE
                           (N.CDFILIEMIT   = C_ETL.CDFILIAL)                AND
                           (N.DTENTRSAID BETWEEN V_DTINI AND V_DTFIM)       AND
                           (N.IDENTRSAIDOP = T.IDENTRSAIDOP)                AND
                           (N.CDTIPOOPER   = T.CDTIPOOPER)                  AND
                           (N.IDENTRSAIDOP = 'S')                           AND
                           (T.IDCOMPDOCROP = 'S')                           AND
                           (N.CDFILIAL    = I.CDFILIAL (+))                 AND
                           (N.NRLANCTONF  = I.NRLANCTONF (+))               AND
                           (I.CDENCARGO (+) = '01')                         AND
                           (I.CDENCARGO    = E.CDENCARGO (+))               AND
                           (E.IDENCARGO (+) <> 'V')
                        GROUP BY
                           N.CDFILIAL,
                           N.NRLANCTONF
                        UNION
                        SELECT
                           N.CDFILIAL,
                           N.NRLANCTONF,
                           ROUND(SUM(DECODE(E.IDENCARGO, 'A',I.VRITEMENCA, I.VRITEMENCA * -1)),2) AS VRFRETE
                        FROM
                           NOTAFISCAL N, TIPOOPERAC T, ENCARGO E, ITEMENCARGO I
                        WHERE
                           (N.CDFILIRECE   = C_ETL.CDFILIAL)                AND
                           (N.DTENTRSAID BETWEEN V_DTINI AND V_DTFIM)       AND
                           (N.IDENTRSAIDOP = T.IDENTRSAIDOP)                AND
                           (N.CDTIPOOPER   = T.CDTIPOOPER)                  AND
                           (N.IDENTRSAIDOP = 'E')                           AND
                           (T.IDCOMPDOCROP = 'S')                           AND
                           (N.CDFILIAL    = I.CDFILIAL (+))                 AND
                           (N.NRLANCTONF  = I.NRLANCTONF (+))               AND
                           (I.CDENCARGO (+) = '01')                         AND
                           (I.CDENCARGO    = E.CDENCARGO (+))               AND
                           (E.IDENCARGO (+) <> 'V')
                        GROUP BY
                           N.CDFILIAL,
                           N.NRLANCTONF
                       ) FR,
                       (SELECT
                           N.CDFILIAL,
                           N.NRLANCTONF,
                           ROUND(SUM(DECODE(E.IDENCARGO, 'A',I.VRITEMENCA, I.VRITEMENCA * -1)),2) AS VROUTROS
                        FROM
                           NOTAFISCAL N, TIPOOPERAC T, ENCARGO E, ITEMENCARGO I
                        WHERE
                           (N.CDFILIEMIT   = C_ETL.CDFILIAL)                AND
                           (N.DTENTRSAID BETWEEN V_DTINI AND V_DTFIM)       AND
                           (N.IDENTRSAIDOP = T.IDENTRSAIDOP)                AND
                           (N.CDTIPOOPER   = T.CDTIPOOPER)                  AND
                           (N.IDENTRSAIDOP = 'S')                           AND
                           (T.IDCOMPDOCROP = 'S')                           AND
                           (N.CDFILIAL    = I.CDFILIAL (+))                 AND
                           (N.NRLANCTONF  = I.NRLANCTONF (+))               AND
                           (I.CDENCARGO (+) <> '01')                        AND
                           (I.CDENCARGO    = E.CDENCARGO (+))               AND
                           (E.IDENCARGO (+) <> 'V')
                        GROUP BY
                           N.CDFILIAL,
                           N.NRLANCTONF
                        UNION
                        SELECT
                           N.CDFILIAL,
                           N.NRLANCTONF,
                           ROUND(SUM(DECODE(E.IDENCARGO, 'A',I.VRITEMENCA, I.VRITEMENCA * -1)),2) AS VROUTROS
                        FROM
                           NOTAFISCAL N, TIPOOPERAC T, ENCARGO E, ITEMENCARGO I
                        WHERE
                           (N.CDFILIRECE   = C_ETL.CDFILIAL)                AND
                           (N.DTENTRSAID BETWEEN  V_DTINI AND V_DTFIM)      AND
                           (N.IDENTRSAIDOP = T.IDENTRSAIDOP)                AND
                           (N.CDTIPOOPER   = T.CDTIPOOPER)                  AND
                           (N.IDENTRSAIDOP = 'E')                           AND
                           (T.IDCOMPDOCROP = 'S')                           AND
                           (N.CDFILIAL    = I.CDFILIAL (+))                 AND
                           (N.NRLANCTONF  = I.NRLANCTONF (+))               AND
                           (I.CDENCARGO (+) <> '01')                        AND
                           (I.CDENCARGO    = E.CDENCARGO (+))               AND
                           (E.IDENCARGO (+) <> 'V')
                        GROUP BY
                           N.CDFILIAL,
                           N.NRLANCTONF
                       ) OU
                    WHERE
                       (NT.CDCLIENTE    = LC.CDCLIENTE (+))    AND
                       (NT.NRLICENCAUSO = LC.NRLICENCAUSO (+)) AND
                       (NT.CDFORNECED   = F.CDFORNECED(+))     AND
                       (NT.CDCLIENTE    = C.CDCLIENTE (+))     AND
                       (G.CDGRUPPROD    = P_GRUPO)             AND
                       (G.CDSUBGRPROD   = NT.CDSUBGRPROD)      AND
                       (NT.CDFILIAL     = FR.CDFILIAL (+))     AND
                       (NT.NRLANCTONF   = FR.NRLANCTONF (+))   AND
                       (NT.CDFILIAL     = OU.CDFILIAL (+))     AND
                       (NT.NRLANCTONF   = OU.NRLANCTONF (+))
                    )
                LOOP
                   IF C_CUSTO.IDCOMPRESROP = 'S' THEN
                      IF (C_CUSTO.IDTPGRPRALIM IS NULL) OR (C_CUSTO.IDTPGRPRALIM <> 5)  THEN
                         IF C_CUSTO.IDENTRSAIDOP = 'E' THEN
                            V_CUSTOCMP     := ROUND(V_CUSTOCMP + (( C_CUSTO.VLRTOTAL +  C_CUSTO.VRIMPIPI +  C_CUSTO.VRCUSTOLOG) -  C_CUSTO.VRIMPICMS -  C_CUSTO.VRIMPPIS +  C_CUSTO.VRFRETE +  C_CUSTO.VROUTROS),2);
                         ELSE
                            V_CUSTOCMP     :=  ROUND(V_CUSTOCMP - (( C_CUSTO.VLRTOTAL +  C_CUSTO.VRIMPIPI +  C_CUSTO.VRCUSTOLOG) -  C_CUSTO.VRIMPICMS -  C_CUSTO.VRIMPPIS +  C_CUSTO.VRFRETE +  C_CUSTO.VROUTROS),2);
                         END IF;
                      ELSE
                         V_DESPESA := ROUND(V_DESPESA + (( C_CUSTO.VLRTOTAL +  C_CUSTO.VRIMPIPI +  C_CUSTO.VRCUSTOLOG) -  C_CUSTO.VRIMPICMS -  C_CUSTO.VRIMPPIS +  C_CUSTO.VRFRETE +  C_CUSTO.VROUTROS),2);                           
                      END IF;
                   END IF;
                END LOOP;
             END;
    /* Mao de Obra */
             BEGIN
                SELECT SUM(VRLANCDESFAT) 
                INTO   V_MOBRA
                FROM   LANCDESPFATU
                WHERE  CDFILIAL = C_ETL.CDFILIAL  
                  AND  DTLANCDESFAT BETWEEN  V_DTINI AND V_DTFIM;
             EXCEPTION
             WHEN OTHERS THEN
                V_MOBRA := V_ZERO;
             END;
     /* Dias uteis */
     /* Calculo do valor de mao de obra ->  VRREALMDO /  TOTDIAUTIL *  TOTDIAUTPE */
             BEGIN
                SELECT A.TOTDIAUTIL, B.TOTDIAUTPE  
                INTO   V_DIAUTIL1, V_DIAUTIL2
                FROM
                       (SELECT COUNT(*) AS TOTDIAUTIL
                        FROM   DATA
                        WHERE  TO_CHAR(DTDATA, 'MM/YYYY') = TO_CHAR( V_DTINI, 'MM/YYYY') 
                          AND  NOT EXISTS (SELECT DTFERIFILI
                                           FROM   FERIFILI
                                           WHERE  CDFILIAL = C_ETL.CDFILIAL  
                                             AND  DTFERIFILI = DATA.DTDATA)) A,
                       (SELECT COUNT(*) AS TOTDIAUTPE
                        FROM   DATA
                        WHERE  DTDATA BETWEEN V_DTINI AND V_DTFIM 
                          AND  NOT EXISTS (SELECT DTFERIFILI
                                           FROM   FERIFILI
                                           WHERE  CDFILIAL = C_ETL.CDFILIAL  
                                             AND  DTFERIFILI = DATA.DTDATA)) B ;
             EXCEPTION
             WHEN OTHERS THEN
                V_DIAUTIL1 := V_ZERO;
                V_DIAUTIL2 := V_ZERO;
             END;
    /* Calculo do valor das despesas gerais ->  (VRREALDESP /  TOTDIAUTIL *  TOTDIAUTPE) +
    valor de NF's cujo subgrupo seja igual a despesas diversas (IDTPGRPRALIM = `5`) */
            
            
             /* Taxa Administrativa Corporativa*/
             /*Clculo -> Faturamento Lquido * Fator;
              Fator = ROP008 / ROP003 */
           
             BEGIN
                IF V_ORCAFATLIQ <> 0 THEN
                   V_TXADM  :=  V_FATLIQ * Round(V_ORCATXADMGER / V_ORCAFATLIQ,4);
                   
                END IF;
             EXCEPTION
                WHEN OTHERS THEN
                   V_TXADM  := V_ZERO;
             END;
            
             /* Taxa Administrativa Regional*/
             /*Clculo -> Faturamento Lquido * Fator;
              Fator = ROP0071 */
           
             V_TXTAR  :=  (V_FATLIQ * V_VRPERCTXTAR)/100;  
     
     
        /* Inventario Anterior */
             BEGIN
                SELECT
                       SUM(P.QTESTDIACON * CUSTO_PRODUTO(C_ETL.CDFILIAL, P.CDPRODUTO, NVL(PA.CDTIPCUSTEST, 3),
                       TO_DATE( V_DTINI - 1), TRUNC(SYSDATE)))
                INTO   V_ESTOQUE_INICIAL
                FROM
                       POSESTCONS P, PARAMFILIAL PA
                WHERE
                       (PA.CDFILIAL = C_ETL.CDFILIAL)  
                  AND  (P.CDFILIAL = PA.CDFILIAL)    
                  AND  (P.DTPOSESTCON = (SELECT MAX(C.DTPOSESTCON)
                                         FROM   POSESTCONS C
                                         WHERE  (C.CDFILIAL   = P.CDFILIAL)       
                                           AND  (C.CDPRODUTO  = P.CDPRODUTO)      
                                           AND  (C.DTPOSESTCON <= V_DTINI)));
             EXCEPTION
             WHEN OTHERS THEN
                V_ESTOQUE_INICIAL := V_ZERO;
             END;
    /* Inventario FINAL */
             BEGIN
                SELECT
                       SUM(P.QTESTDIACON * CUSTO_PRODUTO(C_ETL.CDFILIAL, P.CDPRODUTO, NVL(PA.CDTIPCUSTEST, 3),
                       TO_DATE(V_DTFIM), TRUNC(SYSDATE)))
                INTO   V_ESTOQUE_FINAL
                FROM
                       POSESTCONS P, PARAMFILIAL PA
                WHERE
                       (PA.CDFILIAL = C_ETL.CDFILIAL)   
                  AND  (P.CDFILIAL = PA.CDFILIAL)    
                  AND  (P.DTPOSESTCON = (SELECT MAX(C.DTPOSESTCON)
                                         FROM   POSESTCONS C
                                         WHERE  (C.CDFILIAL   = P.CDFILIAL)       
                                           AND  (C.CDPRODUTO  = P.CDPRODUTO)      
                                           AND  (C.DTPOSESTCON <= TO_DATE(V_DTFIM+1))));
             EXCEPTION
             WHEN OTHERS THEN
                V_ESTOQUE_FINAL := V_ZERO;
             END;
             V_TIPOFATU := CASE  C_ETL.CDTIPOFATUR
                           WHEN '001'  THEN   'Gesto Direta'
                           WHEN '003'  THEN   'Mandato'
                           WHEN '004'  THEN   'Refeies e Servios'
                           WHEN '005'  THEN   'Taxa Fixa'
                           WHEN '006'  THEN   'Gesto Hospitalar'
                           WHEN '007'  THEN   'Produtos e Servios'
                           WHEN '008'  THEN   'Produtos e Servios'
                           ELSE 'Sem Tipo Faturamento'
                           END;
             V_CUSTORETIRADA := V_CUSTORETIRADA + ABS(V_VRAJUSNEGATIVO) - ABS(V_VRAJUSPOSITIVO);
             V_MOBRA   := V_MOBRA / V_DIAUTIL1 * V_DIAUTIL2;
             V_DESPESA := (V_VRREALDESP/V_DIAUTIL1 * V_DIAUTIL2 ) + V_DESPESA;
             
             /*Dados coletados do histrico da filial*/
             BEGIN
                SELECT CDGOPERACHIST, CDSUPERVHIST, NVL(QTFUNCFILIHIST,1)
                INTO   V_CDGOPERAC, V_CDSUPERVISOR, V_QTFUNCFILI
                FROM   HISTFILIAL 
                WHERE  CDFILIAL = C_ETL.CDFILIAL AND TRUNC(DTREFEHIST) BETWEEN V_DTINI AND V_DTFIM;
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                    V_CDGOPERAC    := NULL;
                    V_CDSUPERVISOR := NULL;
                    V_QTFUNCFILI   := 1;
             END;
             
             
             IF (V_FATBRUT <> V_ZERO)OR(V_CUSTORETIRADA <> V_ZERO)OR(V_CUSTOCMP <> V_ZERO)OR(V_MOBRA <> V_ZERO) THEN
                INSERT INTO ETL_RESUGER
                   (CDEMPRESA,     CDFILIAL,       CDAREAGERE ,    CDGOPERAC,
                   CDSUPERVISOR,   CDSEGMER,       CDTIPOFATGER,   ANRESUGER, MERESUGER,
                   BIRESUGER,      TRRESUGER,      SERESUGER,      VRFATBRUGER, VRFATLIQGER,
                   VRIMPOGER,      VRRETIGER,      VRMDOENGER,     VRCUSTOCMP, VRDESPEGER,
                   VRESTOINIGER,   VRESTOFINGER,   VRTXADMGER,     VRTXTARGER,
                   VRORCAFATBRUT,  VRORCAIMPOSTO,  VRORCAFATLIQ,   VRORCARETIGER,
                   VRORCACUSTOCMP, VRORCAMDOENGER, VRORCADESPEGER, VRORCATXADMGER,
                   QTFUNCGER,      VRAJUSPOSGER,   VRAJUSNEGGER,   DTULTATUETL                   
                   )
                VALUES
                   (C_ETL.CDEMPRESA, C_ETL.CDFILIAL, C_ETL.CDAREAGERE, V_CDGOPERAC,
                   V_CDSUPERVISOR, C_ETL.CDSEGMER, V_TIPOFATU, V_DTANO, V_DTMES,
                   (V_BIM || ' Bim'), (V_TRI || ' Tri'), (V_SEM || ' Sem'), V_FATBRUT , V_FATLIQ,
                   V_IMPOSTO, V_CUSTORETIRADA,V_MOBRA,V_CUSTOCMP, V_DESPESA,
                   V_ESTOQUE_INICIAL, V_ESTOQUE_FINAL,V_TXADM, V_TXTAR,
                   V_ORCAFATBRUT, V_ORCAIMPOSTO, V_ORCAFATLIQ, V_ORCARETIGER,
                   V_ORCACUSTOCMP, V_ORCAMDOENGER, V_ORCADESPEGER, V_ORCATXADMGER,
                   V_QTFUNCFILI, V_VRAJUSPOSITIVO, V_VRAJUSNEGATIVO, V_DATA
                   );
                   
                V_COUNTER := V_COUNTER + 1;
                IF V_COUNTER >= 100 THEN
                   COMMIT;
                   V_COUNTER := V_ZERO;
                END IF;
             END IF;
          END IF;    /*Final da condio da comparao de V_DTINI com C_ETL.DTINICIALBI */
       END LOOP;     /*Final do Loop por filial*/
       COMMIT;
       v_dtini := add_months(v_dtini,   1);
    END LOOP;        /*Final do Loop por Data*/
END;
/

/*Realiza o cadastro de Fatos e dimenses*/
begin
   CRIA_FATOS('ETL_RESUGER', 'VRTXTARGER',   'Tx. Adm. Regional (TAR)'   , 'MDR');
   CRIA_FATOS('ETL_RESUGER', 'VRTXADMGER',   'Tx. Adm. Corporativa (TAC)', 'MDR');   
end;
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_RESUSAPORE','5.07.008'); END;
/

